test-release.sh 7.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278
  1. #!/bin/bash
  2. #
  3. # mmgen = Multi-Mode GENerator, a command-line cryptocurrency wallet
  4. # Copyright (C)2013-2022 The MMGen Project <mmgen@tuta.io>
  5. # Licensed under the GNU General Public License, Version 3:
  6. # https://www.gnu.org/licenses
  7. # Public project repositories:
  8. # https://github.com/mmgen/mmgen
  9. # https://gitlab.com/mmgen/mmgen
  10. # Tested on Linux, Armbian, Raspbian, MSYS2
  11. # data.sh must implement:
  12. # list_avail_tests()
  13. # init_groups()
  14. # init_tests()
  15. . 'test/test-release.d/cfg.sh'
  16. do_test() {
  17. set +x
  18. tests="t_$1"
  19. skips="t_$1_skip"
  20. while read skip test; do
  21. [ "$test" ] || continue
  22. echo "${!skips}" | grep -q $skip && continue
  23. if [ "$LIST_CMDS" ]; then
  24. echo $test
  25. else
  26. test_disp=$YELLOW${test/\#/$RESET$MAGENTA\#}$RESET
  27. if [ "${test:0:1}" == '#' ]; then
  28. echo -e "$test_disp"
  29. else
  30. echo -e "${GREEN}Running:$RESET $test_disp"
  31. eval "$test" || {
  32. echo -e $RED"test-release.sh: test '$CUR_TEST' failed at command '$test'"$RESET
  33. exit 1
  34. }
  35. fi
  36. fi
  37. done <<<${!tests}
  38. }
  39. prompt_skip() {
  40. echo -n "Enter 's' to skip, or ENTER to continue: "; read -n1; echo
  41. [ "$REPLY" == 's' ] && return 0
  42. return 1
  43. }
  44. run_tests() {
  45. [ "$LIST_CMDS" ] || echo "Running tests: $1"
  46. for t in $1; do
  47. if [ "$SKIP_ALT_DEP" ]; then
  48. ok=$(for a in $noalt_tests; do if [ $t == $a ]; then echo 'ok'; fi; done)
  49. if [ ! "$ok" ]; then
  50. echo -e "${BLUE}Skipping altcoin test '$t'$RESET"
  51. continue
  52. fi
  53. fi
  54. if [ "$LIST_CMDS" ]; then
  55. eval echo -e '\\n#' $(echo \$i_$t) "\($t\)"
  56. else
  57. eval echo -e "'\n'"\${GREEN}'###' Running $(echo \$i_$t) tests\$RESET
  58. eval echo -e $(echo \$s_$t)
  59. fi
  60. [ "$PAUSE" ] && prompt_skip && continue
  61. CUR_TEST=$t
  62. do_test $t
  63. [ "$LIST_CMDS" ] || eval echo -e $(echo \$f_$t)
  64. done
  65. }
  66. check_tests() {
  67. for i in $tests; do
  68. echo "$dfl_tests $extra_tests" | grep -q "\<$i\>" || {
  69. echo "$i: unrecognized argument"
  70. exit 1
  71. }
  72. done
  73. }
  74. remove_skipped_tests() {
  75. tests=$(for t in $tests; do
  76. [ "$(for s in $SKIP_LIST; do [ $t == $s ] && echo y; done)" ] && continue
  77. echo $t
  78. done)
  79. tests=$(echo $tests)
  80. }
  81. list_group_symbols() {
  82. echo -e "Default tests:\n $dfl_tests"
  83. echo -e "Extra tests:\n $extra_tests"
  84. echo -e "'noalt' test group:\n $noalt_tests"
  85. echo -e "'quick' test group:\n $quick_tests"
  86. echo -e "'qskip' test group:\n $qskip_tests"
  87. }
  88. if [ "$(uname -m)" == 'armv7l' ]; then
  89. ARM32=1
  90. elif [ "$(uname -m)" == 'aarch64' ]; then
  91. ARM64=1
  92. elif uname -a | grep -q 'MSYS'; then
  93. MSYS2=1;
  94. fi
  95. if [ "$MSYS2" ]; then
  96. DISTRO='MSYS2'
  97. else
  98. DISTRO=$(grep '^ID=' '/etc/os-release' | cut -c 4-)
  99. [ "$DISTRO" ] || { echo 'Unable to determine distro. Aborting'; exit 1; }
  100. fi
  101. trap 'echo -e "${GREEN}Exiting at user request$RESET"; exit' INT
  102. umask 0022
  103. export MMGEN_TEST_SUITE=1
  104. export MMGEN_NO_LICENSE=1
  105. export PYTHONPATH=.
  106. test_py='test/test.py -n'
  107. objtest_py='test/objtest.py'
  108. objattrtest_py='test/objattrtest.py'
  109. unit_tests_py='test/unit_tests.py --names --quiet'
  110. tooltest_py='test/tooltest.py'
  111. tooltest2_py='test/tooltest2.py --names --quiet'
  112. gentest_py='test/gentest.py --quiet'
  113. scrambletest_py='test/scrambletest.py'
  114. altcoin_mod_opts='--quiet'
  115. mmgen_tool='cmds/mmgen-tool'
  116. python='python3'
  117. rounds=10
  118. ORIG_ARGS=$@
  119. PROGNAME=$(basename $0)
  120. init_groups
  121. while getopts hAbCdDfFLlNOps:StvV OPT
  122. do
  123. case "$OPT" in
  124. h) printf " %-16s Test MMGen release\n" "${PROGNAME}:"
  125. echo " USAGE: $PROGNAME [options] [tests or test group]"
  126. echo " OPTIONS: -h Print this help message"
  127. echo " -A Skip tests requiring altcoin modules or daemons"
  128. echo " -b Buffer keypresses for all invocations of 'test/test.py'"
  129. echo " -C Run tests in coverage mode"
  130. echo " -d Enable Python Development Mode"
  131. echo " -D Run tests in deterministic mode"
  132. echo " -f Speed up the tests by using fewer rounds"
  133. echo " -F Reduce rounds even further"
  134. echo " -L List available tests and test groups with description"
  135. echo " -l List the test name symbols"
  136. echo " -N Pass the --no-timings switch to test/test.py"
  137. echo " -O Use pexpect.spawn rather than popen_spawn where applicable"
  138. echo " -p Pause between tests"
  139. echo " -s LIST Skip tests in LIST (space-separated)"
  140. echo " -S Build SDIST distribution, unpack, and run test"
  141. echo " -t Print the tests without running them"
  142. echo " -v Run test/test.py with '--exact-output' and other commands"
  143. echo " with '--verbose' switch"
  144. echo " -V Run test/test.py and other commands with '--verbose' switch"
  145. echo
  146. echo " For traceback output and error file support, set the EXEC_WRAPPER_TRACEBACK"
  147. echo " environment var"
  148. exit ;;
  149. A) SKIP_ALT_DEP=1
  150. test_py+=" --no-altcoin"
  151. unit_tests_py+=" --no-altcoin-deps"
  152. scrambletest_py+=" --no-altcoin" ;;
  153. b) test_py+=" --buf-keypress" ;;
  154. C) mkdir -p 'test/trace'
  155. touch 'test/trace.acc'
  156. test_py+=" --coverage"
  157. tooltest_py+=" --coverage"
  158. tooltest2_py+=" --fork --coverage"
  159. scrambletest_py+=" --coverage"
  160. python="python3 -m trace --count --file=test/trace.acc --coverdir=test/trace"
  161. unit_tests_py="$python $unit_tests_py"
  162. objtest_py="$python $objtest_py"
  163. objattrtest_py="$python $objattrtest_py"
  164. gentest_py="$python $gentest_py"
  165. mmgen_tool="$python $mmgen_tool" ;&
  166. d) export PYTHONDEVMODE=1
  167. export PYTHONWARNINGS='error' ;;
  168. D) export MMGEN_TEST_SUITE_DETERMINISTIC=1
  169. export MMGEN_DISABLE_COLOR=1 ;;
  170. f) rounds=6 FAST=1 fast_opt='--fast' unit_tests_py+=" --fast" ;;
  171. F) rounds=3 FAST=1 fast_opt='--fast' unit_tests_py+=" --fast" ;;
  172. L) list_avail_tests; exit ;;
  173. l) list_group_symbols; exit ;;
  174. N) test_py+=" --no-timings" ;;
  175. O) test_py+=" --pexpect-spawn" ;;
  176. p) PAUSE=1 ;;
  177. s) SKIP_LIST+=" $OPTARG" ;;
  178. S) SDIST_TEST=1 ;;
  179. t) LIST_CMDS=1 ;;
  180. v) EXACT_OUTPUT=1 test_py+=" --exact-output" ;&
  181. V) VERBOSE='--verbose'
  182. [ "$EXACT_OUTPUT" ] || test_py+=" --verbose"
  183. unit_tests_py="${unit_tests_py/--quiet/--verbose}"
  184. altcoin_mod_opts="${altcoin_mod_opts/--quiet/--verbose}"
  185. tooltest2_py="${tooltest2_py/--quiet/--verbose}"
  186. gentest_py="${gentest_py/--quiet/--verbose}"
  187. tooltest_py+=" --verbose"
  188. mmgen_tool+=" --verbose"
  189. objattrtest_py+=" --verbose"
  190. scrambletest_py+=" --verbose" ;;
  191. *) exit ;;
  192. esac
  193. done
  194. [ "$MMGEN_DISABLE_COLOR" ] || {
  195. RED="\e[31;1m" GREEN="\e[32;1m" YELLOW="\e[33;1m" BLUE="\e[34;1m" MAGENTA="\e[35;1m" CYAN="\e[36;1m"
  196. RESET="\e[0m"
  197. }
  198. [ "$MSYS2" -a ! "$FAST" ] && tooltest2_py+=' --fork'
  199. [ "$EXACT_OUTPUT" -o "$VERBOSE" ] || objtest_py+=" -S"
  200. shift $((OPTIND-1))
  201. [ "$SDIST_TEST" -a -z "$MMGEN_TEST_RELEASE_IN_SDIST" ] && {
  202. test_dir='.sdist-test'
  203. rm -rf build dist MMGen.egg-info $test_dir
  204. python3 -m build --no-isolation --sdist
  205. mkdir $test_dir
  206. tar -C $test_dir -axf dist/*.tar.gz
  207. cd $test_dir/MMGen-*
  208. python3 setup.py build_ext --inplace
  209. echo -e "\n${BLUE}Running 'test/test-release $ORIG_ARGS'$RESET $YELLOW[PWD=$PWD]$RESET\n"
  210. export MMGEN_TEST_RELEASE_IN_SDIST=1
  211. test/test-release.sh $ORIG_ARGS
  212. exit
  213. }
  214. case $1 in
  215. '') tests=$dfl_tests ;;
  216. 'default') tests=$dfl_tests ;;
  217. 'extra') tests=$extra_tests ;;
  218. 'noalt') tests=$noalt_tests
  219. SKIP_ALT_DEP=1
  220. test_py+=" --no-altcoin"
  221. unit_tests_py+=" --no-altcoin-deps"
  222. scrambletest_py+=" --no-altcoin" ;;
  223. 'quick') tests=$quick_tests ;;
  224. 'qskip') tests=$qskip_tests ;;
  225. *) tests="$*" ;;
  226. esac
  227. set -e
  228. rounds_min=$((rounds / 2))
  229. for n in 2 5 10 20 50 100 200 500 1000; do
  230. eval "rounds${n}x=$((rounds*n))"
  231. done
  232. init_tests
  233. remove_skipped_tests
  234. check_tests
  235. start_time=$(date +%s)
  236. run_tests "$tests"
  237. elapsed=$(($(date +%s)-start_time))
  238. elapsed_fmt=$(printf %02d:%02d $((elapsed/60)) $((elapsed%60)))
  239. [ "$LIST_CMDS" ] || {
  240. if [ "$MMGEN_TEST_SUITE_DETERMINISTIC" ]; then
  241. echo -e "${GREEN}All OK"
  242. else
  243. echo -e "${GREEN}All OK. Total elapsed time: $elapsed_fmt$RESET"
  244. fi
  245. }